#!/bin/bash

# Set the desired number of cores (use 1 less than the number of physical cores)
GNU_PAR_CORES=15

rm -f /tmp/timinglist.txt
PWD=$(pwd)
echo "cd $PWD/rbcdef/ && bash ./run.sh"                 >> /tmp/timinglist.txt
echo "cd $PWD/fortran_multi/ && bash ./run_joblist1.sh" >> /tmp/timinglist.txt
echo "cd $PWD/fortran_multi/ && bash ./run_joblist2.sh" >> /tmp/timinglist.txt
echo "cd $PWD/fortran_multi/ && bash ./run_joblist3.sh" >> /tmp/timinglist.txt
echo "cd $PWD/fortran_multi/ && bash ./run_joblist4.sh" >> /tmp/timinglist.txt

i=0

while read myline
do
    let "i++"
    cat > job$i.sh << EOF
#!/bin/bash
#PBS -l nodes=1:ppn=16
#PBS -l walltime=00:06:00:00
#PBS -N logmono
#PBS -V

ulimit -s hard
ulimit -s unlimited

export OMP_NUM_THREADS=1
export GNU_PAR_CORES=$GNU_PAR_CORES
export OMP_STACKSIZE=2M

cd $PWD
source ./setenv.sh
# make clean
make

# Execute the line
EOF

    # Add the actual line
    echo $myline >> job$i.sh

done </tmp/timinglist.txt
