// #include <iostream>
// #include <greyaux>
#include <stdio.h>
#include <new>
#include <thrust/host_vector.h>
#include <thrust/device_vector.h>
#include <thrust/sequence.h>
#include <thrust/copy.h>
#include <thrust/fill.h>
#include <thrust/version.h>
// #include "greyaux.h"

template <class T,class U>
void linspace(T &x,U a,U b, int n){
    U m;
    int i;
    const U one = (U) 1;
    
    x[0] = a;
    for (i=1; i<n-1; i++){
        m = (U)i/(n-1); // casts int i into type U
        x[i] = a*(one-m) + b*m;
    }
    x[n-1] = b;

    return;

}

template <class T>
void disp(const T &x,int n){
    int i;
    for (i=0; i<n; i++) {
        std::cout << x[i] << std::endl;
    }
//         printf(fmt,x[i]);
}

int main(){

    int n=7; 
//    double *y;

    int major = THRUST_MAJOR_VERSION;
    int minor = THRUST_MINOR_VERSION;

    std::cout << "Thrust v" << major << "." << minor << std::endl;
    
//    y = new double[n];

    // linspace(x,-3.,3.,n);
    
    thrust::host_vector<float> x(n);

    // generate linearly spaced elements
//    thrust::sequence(x.begin(), x.end(), -3., 1.);

    linspace(x,-3.f,3.f,x.size());
    disp(x,x.size());


//     for (i = 0; i < x.size(); i++) 
//         std::cout << "x[" << i << "] = " << x[i] << std::endl;

    return 0;

//     printf("Linearly spaced grid of %i points from %f to %f:\n",i,x[0],x[n-1]);
// //     disp(x,n);
// 
//     printf("Normal cdf evaluated at x\n");
//     for (i = 0; i<n; i++){
//         y[i] = normcdf(x[i],0.,1.);
//     }
//     disp(y,n);
// 
//     struct ndarray z;
// 
//     z = alloc(3,5,12);
// 
//     printf("size %i\n",z.size);
//     printf("ndims %i\n",z.ndims);
//     printf("n[0] %i\n",z.n[0]);
//     printf("n[1] %i\n",z.n[1]);
//     printf("n[2] %i\n",z.n[2]);
//     printf("n[3] %i\n",z.n[3]);
// 
    

//    return 0;
}
