#!/bin/bash

nvcc --gpu-architecture=sm_30 ./src/culibgrey.cu ./src/culibtest.cu --output-file ./test/cutest.out -lcublas -lblas

exit 

# compile all .cu files to .o files
# nvcc --gpu-architecture=sm_30 ./src/culibgrey.cu ./src/culibtest.cu --output-file ./test/cutest.out -lcublas 
# nvcc --gpu-architecture=sm_30 --device-link ./src/culibgrey.cu ./src/culibtest.cu --output-file ./test/cutest.out -lcublas 

# # link the cuda .o files together
# echo "Linking .cu object files"
# nvcc --gpu-architecture=sm_30 --device-link ./cuobj/culibgrey.o ./cuobj/culibtest.o --output-file ./cuobj/cuda_objs.o
# 
# 
# # There is a bug i think with nvcc that causes a linking issue below (cf http://www.widecodes.com/CJVjPXeeXe/activating-cuda-dynamic-parallelism-undefined-reference-to-fatbinwrap.html)

# compile all .cu files to .o files
echo "Compiling .cu files"
echo "1st:"
nvcc --gpu-architecture=sm_30 --device-c ./src/culibgrey.cu --output-file ./cuobj/culibgrey.o
echo "2nd:"
nvcc --gpu-architecture=sm_30 --device-c ./src/culibtest.cu --output-file ./cuobj/culibtest.o

# link the cuda .o files together
echo "Linking .cu object files"
nvcc --gpu-architecture=sm_30 --device-link ./cuobj/culibgrey.o ./cuobj/culibtest.o --output-file ./cuobj/cuda_objs.o -lcudart -lcudadevrt

# There is a bug i think with nvcc that causes a linking issue below (cf http://www.widecodes.com/CJVjPXeeXe/activating-cuda-dynamic-parallelism-undefined-reference-to-fatbinwrap.html)

# compile desired .cpp files to .o files 
echo "Compiled .cpp files"
# mpicxx -c ./src/clibgrey.cpp -o ./cuobj/clibgrey.o -I./src/ #-I/usr/local/cuda/include # culibtest included cuda code

# now compile with host
echo "Linking all object files "
# mpicxx ./cuobj/cuda_objs.o            -L/usr/local/cuda/lib -lcudart -lcudadevrt -lcublas  
mpicxx ./cuobj/cuda_objs.o            -L/usr/local/cuda/lib -lcudart -lcudadevrt -lcublas  
# mpicxx cuda_objs.o -o $(LIBGREY)/lcugrey.a -lcudart


