! Generic print function 
!
! On 11/20/12, I switched to the "new" routines. The old ones are still there for compatibility,
! but if they need to be read, then I think a conversion routine will need to be written first.
!
module mod_myprint
implicit none

interface myprint_old
    module procedure pr_d_0,pr_d_1,pr_d_2,pr_d_3,pr_d_4,pr_d_5,&
                     pr_i_0,pr_i_1,pr_i_2,pr_i_3,pr_i_4,pr_i_5,&
                     pr_l_0,pr_l_1,pr_l_2,pr_l_3,pr_l_4,pr_l_5
end interface myprint_old

interface myread_old
    module procedure read_d_0,read_d_1,read_d_2,read_d_3,read_d_4,read_d_5,&
                     read_i_0,read_i_1,read_i_2,read_i_3,read_i_4,read_i_5,&
                     read_l_0,read_l_1,read_l_2,read_l_3,read_l_4,read_l_5
end interface myread_old


interface myprint
    module procedure pr_d_0_new,pr_d_1_new,pr_d_2_new,pr_d_3_new,pr_d_4_new,pr_d_5_new,pr_d_6_new,pr_d_7_new,&
                     pr_i_0_new,pr_i_1_new,pr_i_2_new,pr_i_3_new,pr_i_4_new,pr_i_5_new,&
                     pr_l_0_new,pr_l_1_new,pr_l_2_new,pr_l_3_new,pr_l_4_new,pr_l_5_new
end interface myprint

interface myread
    module procedure read_d_0_new,read_d_1_new,read_d_2_new,read_d_3_new,read_d_4_new,read_d_5_new,&
                     read_i_0_new,read_i_1_new,read_i_2_new,read_i_3_new,read_i_4_new,&
                     read_l_0_new,read_l_1_new,read_l_2_new,read_l_3_new,read_l_4_new
end interface myread


character(LEN=*), parameter, private :: pr_fmt_d_new='(1PE23.15E3)'
character(LEN=*), parameter, private :: pr_fmt_d='(e40.16e4)'
character(LEN=*), parameter, private :: pr_fmt_i='(i8)'

character(LEN=*), parameter :: ext = '.txt'

character(LEN=120) :: directory = './results/' !Default directory
character(LEN=120) :: scratchdirectory

integer, parameter :: MYREAD_SUCCESS = 0, MYREAD_FAILURE = -1

!!! PUT THESE AS LOCAL VARIABLES ASAP
integer, private :: unit_no
character(LEN=240), private :: filename,fileheader
logical, private :: exist_bool
integer, private :: io_error

contains

subroutine test_myread()
    implicit none 
    real(8) :: a(450),b(452),v(300,39,2),v2(300,39,2),s
    call usedir('~/Dropbox/Work/libgrey/test/')

    call myread('grid_a',a)
    print *, a
    print * 

    call myread('Ev',v)

    v2 = v
    call myprint('v2',v2)
    call myprint_old('v2_old',v2)

    v2 = -1.d0
    call myread('v2',v2)
    call myprint('v2_check',v2)

    b = (/a,huge(0.d0)/10.d0,tiny(0.d0)/)

    ! Check new format
    call pr_d_1_new('b',b)
    
    ! Check old format
    call pr_d_1('b_old',b)

    b = -1.d0
    call read_d_1('b',b)
! 
!     write(*,pr_fmt_d_new), b
    write(*,*) b

    s = 3.d0
    call myprint('s',s)
!     s = 1.d0
!     print*,'size(s)'
!     print*, size(s)
          
end subroutine test_myread


!PRINT
!!! DOUBLE PRECISION
subroutine pr_d_0_new(str,obj)
    implicit none 
    real(8), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    call pr_d_1_new(str,(/obj/)) ! Convert to a 1-dim length-1 array
end subroutine pr_d_0_new
subroutine pr_d_1_new(str,obj)
    implicit none
    real(8), dimension(1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_d.f90'
end subroutine pr_d_1_new
subroutine pr_d_2_new(str,obj)
    implicit none
    real(8), dimension(1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_d.f90'
end subroutine pr_d_2_new
subroutine pr_d_3_new(str,obj)
    implicit none
    real(8), dimension(1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_d.f90'
end subroutine pr_d_3_new
subroutine pr_d_4_new(str,obj)
    implicit none
    real(8), dimension(1:,1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_d.f90'
end subroutine pr_d_4_new
subroutine pr_d_5_new(str,obj)
    implicit none
    real(8), dimension(1:,1:,1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_d.f90'
end subroutine pr_d_5_new
subroutine pr_d_6_new(str,obj)
    implicit none
    real(8), dimension(1:,1:,1:,1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_d.f90'
end subroutine pr_d_6_new
subroutine pr_d_7_new(str,obj)
    implicit none
    real(8), dimension(1:,1:,1:,1:,1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_d.f90'
end subroutine pr_d_7_new
!!! INTEGER
subroutine pr_i_0_new(str,obj)
    implicit none 
    integer, intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    call pr_i_1_new(str,(/obj/)) ! Convert to a 1-dim length-1 array
end subroutine pr_i_0_new
subroutine pr_i_1_new(str,obj)
    implicit none
    integer, dimension(1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_i.f90'
end subroutine 
subroutine pr_i_2_new(str,obj)
    implicit none
    integer, dimension(1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_i.f90'
end subroutine 
subroutine pr_i_3_new(str,obj)
    implicit none
    integer, dimension(1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_i.f90'
end subroutine 
subroutine pr_i_4_new(str,obj)
    implicit none
    integer, dimension(1:,1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_i.f90'
end subroutine 
subroutine pr_i_5_new(str,obj)
    implicit none
    integer, dimension(1:,1:,1:,1:,1:), intent(in) :: obj
    include 'mod_myprint_auxwrite_i.f90'
end subroutine 
!!! LOGICALS
subroutine pr_l_0_new(str,obj)
    implicit none
    logical, intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer :: obj_i
    obj_i = merge(1,0,obj)
    call pr_i_0_new(str,obj_i)
end subroutine pr_l_0_new
subroutine pr_l_1_new(str,obj)
    implicit none
    logical, dimension(:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, allocatable, dimension(:) :: obj_i
    allocate(obj_i(size(obj,1)))
    obj_i = merge(1,0,obj)
    call pr_i_1_new(str,obj_i)
end subroutine pr_l_1_new
subroutine pr_l_2_new(str,obj)
    implicit none
    logical, dimension(:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, allocatable, dimension(:,:) :: obj_i
    allocate(obj_i(size(obj,1),size(obj,2)))
    obj_i = merge(1,0,obj)
    call pr_i_2_new(str,obj_i)
end subroutine pr_l_2_new
subroutine pr_l_3_new(str,obj)
    implicit none
    logical, dimension(:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, allocatable, dimension(:,:,:) :: obj_i
    allocate(obj_i(size(obj,1),size(obj,2),size(obj,3)))
    obj_i = merge(1,0,obj)
    call pr_i_3_new(str,obj_i)
end subroutine pr_l_3_new
subroutine pr_l_4_new(str,obj)
    implicit none
    logical, dimension(:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, allocatable, dimension(:,:,:,:) :: obj_i
    allocate(obj_i(size(obj,1),size(obj,2),size(obj,3),size(obj,4)))
    obj_i = merge(1,0,obj)
    call pr_i_4_new(str,obj_i)
end subroutine pr_l_4_new
subroutine pr_l_5_new(str,obj)
    implicit none
    logical, dimension(:,:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, allocatable, dimension(:,:,:,:,:) :: obj_i
    allocate(obj_i(size(obj,1),size(obj,2),size(obj,3),size(obj,4),size(obj,5)))
    obj_i = merge(1,0,obj)
    call pr_i_5_new(str,obj_i)
end subroutine 


!READ
!!! DOUBLE PRECISION
subroutine read_d_0_new(str,obj,err)
    implicit none
    real(8), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    !local
    real(8) :: tmp(1)
    if (present(err)) then
        call read_d_1_new(str,tmp,err)
    else
        call read_d_1_new(str,tmp)
    end if
    obj = tmp(1)
end subroutine read_d_0_new
subroutine read_d_1_new(str,obj,err)
    implicit none
    real(8), dimension(1:), intent(out) :: obj    
    integer, dimension(1) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_d_1_new
subroutine read_d_2_new(str,obj,err)
    implicit none
    real(8), dimension(1:,1:), intent(out) :: obj    
    integer, dimension(2) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_d_2_new
subroutine read_d_3_new(str,obj,err)
    implicit none
    real(8), dimension(1:,1:,1:), intent(out) :: obj    
    integer, dimension(3) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_d_3_new
subroutine read_d_4_new(str,obj,err)
    implicit none
    real(8), dimension(1:,1:,1:,1:), intent(out) :: obj    
    integer, dimension(4) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_d_4_new
subroutine read_d_5_new(str,obj,err)
    implicit none
    real(8), dimension(1:,1:,1:,1:,1:), intent(out) :: obj    
    integer, dimension(5) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_d_5_new
!!! INTEGER
subroutine read_i_0_new(str,obj,err)
    implicit none
    integer, intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    !local
    integer :: tmp(1)
    if (present(err)) then
        call read_i_1_new(str,tmp,err)
    else
        call read_i_1_new(str,tmp)
    end if
    obj = tmp(1)
end subroutine read_i_0_new
subroutine read_i_1_new(str,obj,err)
    implicit none
    integer, dimension(1:), intent(out) :: obj    
    integer, dimension(1) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_i_1_new
subroutine read_i_2_new(str,obj,err)
    implicit none
    integer, dimension(1:,1:), intent(out) :: obj    
    integer, dimension(2) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_i_2_new
subroutine read_i_3_new(str,obj,err)
    implicit none
    integer, dimension(1:,1:,1:), intent(out) :: obj    
    integer, dimension(3) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_i_3_new
subroutine read_i_4_new(str,obj,err)
    implicit none
    integer, dimension(1:,1:,1:,1:), intent(out) :: obj    
    integer, dimension(4) :: dims
    include 'mod_myprint_auxread.f90'
end subroutine read_i_4_new
!!!LOGICAL
subroutine read_l_0_new(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, intent(out) :: obj
    integer, intent(out), optional :: err
    integer :: obj_i
    if (present(err)) then
        call read_i_0_new(str,obj_i,err)
    else
        call read_i_0_new(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_0_new
subroutine read_l_1_new(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1)) :: obj_i
    if (present(err)) then
        call read_i_1_new(str,obj_i,err)
    else
        call read_i_1_new(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_1_new
subroutine read_l_2_new(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:,:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1),1:size(obj,2)) :: obj_i
    if (present(err)) then
        call read_i_2_new(str,obj_i,err)
    else
        call read_i_2_new(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_2_new
subroutine read_l_3_new(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:,:,:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1),1:size(obj,2),1:size(obj,3)) :: obj_i
    if (present(err)) then
        call read_i_3_new(str,obj_i,err)
    else
        call read_i_3_new(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_3_new
subroutine read_l_4_new(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:,:,:,:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1),1:size(obj,2),1:size(obj,3),1:size(obj,4)) :: obj_i
    if (present(err)) then
        call read_i_4_new(str,obj_i,err)
    else
        call read_i_4_new(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_4_new
















! Read real arrays
subroutine read_d_0(str,obj,err)
    implicit none
    real(8), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:1) :: dims
    ! real(8) :: vec
    if (present(err)) err = MYREAD_SUCCESS
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    !---check that dimensions agree
    if (dims(1)/=1) then 
        write(*,*) 'ERROR: read_d_0: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', 1
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_d,iostat=io_error) obj
    close(unit_no)
    call check_io_error(io_error,filename)
end subroutine read_d_0
subroutine read_d_1(str,obj,err)
    implicit none
    real(8), dimension(1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:1) :: dims
    real(8), dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !--check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_d_1: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_d,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_d_1
subroutine read_d_2(str,obj,err)
    implicit none
    real(8), dimension(1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:2) :: dims
    real(8), dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !--check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_d_2: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_d,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_d_2
subroutine read_d_3(str,obj,err)
    implicit none
    real(8), dimension(1:,1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:3) :: dims
    real(8), dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !--check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_d_3: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_d,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_d_3
subroutine read_d_4(str,obj,err)
    implicit none
    real(8), dimension(1:,1:,1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:4) :: dims
    real(8), dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !--check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_d_4: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_d,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_d_4
subroutine read_d_5(str,obj,err)
    implicit none
    real(8), dimension(1:,1:,1:,1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:5) :: dims
    real(8), dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !--check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_d_5: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_d,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_d_5

! Read integer arrays
subroutine read_i_0(str,obj,err)
    implicit none
    integer, intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:1) :: dims
    ! integer :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    !---check that dimensions agree
    if (dims(1)/=1) then
        write(*,*) 'ERROR: read_i_0: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', 1
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) obj
    close(unit_no)
    call check_io_error(io_error,filename)
end subroutine read_i_0
subroutine read_i_1(str,obj,err)
    implicit none
    integer, dimension(1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:1) :: dims
    integer, dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !---check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_i_1: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_i_1
subroutine read_i_2(str,obj,err)
    implicit none
    integer, dimension(1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:2) :: dims
    integer, dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !---check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_i_2: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_i_2
subroutine read_i_3(str,obj,err)
    implicit none
    integer, dimension(1:,1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:3) :: dims
    integer, dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !---check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_i_3: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_i_3
subroutine read_i_4(str,obj,err)
    implicit none
    integer, dimension(1:,1:,1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:4) :: dims
    integer, dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !---check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_i_4: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_i_4
subroutine read_i_5(str,obj,err)
    implicit none
    integer, dimension(1:,1:,1:,1:,1:), intent(out) :: obj    
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err
    integer, dimension(1:5) :: dims
    integer, dimension(:), allocatable :: vec
    if (present(err)) err = MYREAD_SUCCESS    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    
    !---make sure file and header file exist
    inquire(file=filename,exist=exist_bool)
    call check_exist_bool(exist_bool,filename)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    inquire(file=fileheader,exist=exist_bool)
    call check_exist_bool(exist_bool,fileheader)
    if (.NOT. exist_bool) then 
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP 'read: no error flag present'
        end if
    end if
    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    !---check that dimensions agree
    if (any(shape(obj)/=dims)) then
        write(*,*) 'ERROR: read_i_5: dims don''t agree'
        write(*,*) 'File: '//str
        write(*,*) 'Dims in header: ', dims
        write(*,*) 'Dims in object: ', shape(obj)
        if (present(err)) then
            err = MYREAD_FAILURE
            return
        else
            STOP
        end if
    end if
    !---open and read in file
    allocate(vec(product(dims)))
    open(unit_no,file=filename,status='old')
    read(unit_no,pr_fmt_i,iostat=io_error) vec
    close(unit_no)
    call check_io_error(io_error,filename)
    !---reshape output
    obj = reshape(vec,dims)
    deallocate(vec)
end subroutine read_i_5

!logical arrays
subroutine read_l_0(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, intent(out) :: obj
    integer, intent(out), optional :: err
    integer :: obj_i
    if (present(err)) then
        call read_i_0(str,obj_i,err)
    else
        call read_i_0(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_0
subroutine read_l_1(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1)) :: obj_i
    if (present(err)) then
        call read_i_1(str,obj_i,err)
    else
        call read_i_1(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_1
subroutine read_l_2(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:,:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1),1:size(obj,2)) :: obj_i
    if (present(err)) then
        call read_i_2(str,obj_i,err)
    else
        call read_i_2(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_2
subroutine read_l_3(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:,:,:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1),1:size(obj,2),1:size(obj,3)) :: obj_i
    if (present(err)) then
        call read_i_3(str,obj_i,err)
    else
        call read_i_3(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_3
subroutine read_l_4(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:,:,:,:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1),1:size(obj,2),1:size(obj,3),1:size(obj,4)) :: obj_i
    if (present(err)) then
        call read_i_4(str,obj_i,err)
    else
        call read_i_4(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_4
subroutine read_l_5(str,obj,err)
    implicit none
    character(LEN=*), intent(in) :: str
    logical, dimension(:,:,:,:,:), intent(out) :: obj
    integer, intent(out), optional :: err
    integer, dimension(1:size(obj,1),1:size(obj,2),1:size(obj,3),1:size(obj,4),1:size(obj,5)) :: obj_i
    if (present(err)) then
        call read_i_5(str,obj_i,err)
    else
        call read_i_5(str,obj_i)
    end if
    obj = obj_i == 1
end subroutine read_l_5

subroutine pr_d_0(str,obj)
    implicit none
    real(8), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
    write(unit_no,pr_fmt_d) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) 1
    close(unit_no)
end subroutine pr_d_0
subroutine pr_d_1(str,obj)
    
    implicit none
    real(8), dimension(:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
!     write(unit_no,pr_fmt_d) reshape(obj,(/size(obj)/))
    write(unit_no,pr_fmt_d) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_d_1
subroutine pr_d_2(str,obj)
    implicit none
    real(8), dimension(:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
!     write(unit_no,pr_fmt_d) reshape(obj,(/size(obj)/))
    write(unit_no,pr_fmt_d) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_d_2
subroutine pr_d_3(str,obj)
    implicit none
    real(8), dimension(:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
!     write(unit_no,pr_fmt_d) reshape(obj,(/size(obj)/))
    write(unit_no,pr_fmt_d) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_d_3
subroutine pr_d_4(str,obj)
    implicit none
    real(8), dimension(:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
            !write(unit_no,pr_fmt_d) reshape(obj,(/size(obj)/))
! write(*,*) 'pr_d_4: shape of obj',shape(obj)
    write(unit_no,pr_fmt_d) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_d_4
subroutine pr_d_5(str,obj)
    implicit none
    real(8), dimension(:,:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
            !write(unit_no,pr_fmt_d) reshape(obj,(/size(obj)/))
! write(*,*) 'pr_d_4: shape of obj',shape(obj)
    write(unit_no,pr_fmt_d) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_d_5


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! integer
subroutine pr_i_0(str,obj)
    
    implicit none
    integer, intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
    write(unit_no,pr_fmt_i) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) 1
    close(unit_no)
end subroutine pr_i_0
subroutine pr_i_1(str,obj)
    
    implicit none
    integer, dimension(:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
    write(unit_no,pr_fmt_i) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_i_1
subroutine pr_i_2(str,obj)
    
    implicit none
    integer, dimension(:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
    write(unit_no,pr_fmt_i) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_i_2
subroutine pr_i_3(str,obj)
    
    implicit none
    integer, dimension(:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
    write(unit_no,pr_fmt_i) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_i_3
subroutine pr_i_4(str,obj)
    
    implicit none
    integer, dimension(:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
    write(unit_no,pr_fmt_i) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_i_4
subroutine pr_i_5(str,obj)
    
    implicit none
    integer, dimension(:,:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext
    call get_unit_no(unit_no)
    ! Write file
    open(unit_no,file=filename,status='replace')
    write(unit_no,pr_fmt_i) obj
    close(unit_no)
    ! Write file header that gives dimensions
    open(unit_no,file=fileheader,status='replace')
    write(unit_no,pr_fmt_i) shape(obj)
    close(unit_no)
end subroutine pr_i_5

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! logicals
subroutine pr_l_0(str,obj)
    implicit none
    logical, intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer :: obj_i
    obj_i = merge(1,0,obj)
    call pr_i_0(str,obj_i)
end subroutine pr_l_0
subroutine pr_l_1(str,obj)
    implicit none
    logical, dimension(:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, dimension(size(obj,1)) :: obj_i
    obj_i = merge(1,0,obj)
    call pr_i_1(str,obj_i)
end subroutine pr_l_1
subroutine pr_l_2(str,obj)
    implicit none
    logical, dimension(:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, dimension(size(obj,1),size(obj,2)) :: obj_i
    obj_i = merge(1,0,obj)
    call pr_i_2(str,obj_i)
end subroutine pr_l_2
subroutine pr_l_3(str,obj)
    
    implicit none
    logical, dimension(:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, dimension(size(obj,1),size(obj,2),size(obj,3)) :: obj_i
    obj_i = merge(1,0,obj)
    call pr_i_3(str,obj_i)
end subroutine pr_l_3
subroutine pr_l_4(str,obj)
    implicit none
    logical, dimension(:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, dimension(size(obj,1),size(obj,2),size(obj,3),size(obj,4)) :: obj_i
    obj_i = merge(1,0,obj)
    call pr_i_4(str,obj_i)
end subroutine pr_l_4
subroutine pr_l_5(str,obj)
    implicit none
    logical, dimension(:,:,:,:,:), intent(in) :: obj
    character(LEN=*), intent(in) :: str    
    integer, dimension(size(obj,1),size(obj,2),size(obj,3),size(obj,4),size(obj,5)) :: obj_i
    obj_i = merge(1,0,obj)
    call pr_i_5(str,obj_i)
end subroutine pr_l_5

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Auxiliary Routines
function getdir() result(dir)
    implicit none
    character(LEN=180) :: dir
    dir = directory
end function

subroutine usedir(dir)
    implicit none
    character(LEN=*), intent(in) :: dir
    scratchdirectory = directory
    directory = dir
end subroutine

subroutine revertdir()
    directory = scratchdirectory
end subroutine

subroutine check_io_error(io_error,file)
    implicit none
    integer, intent(in) :: io_error
    character(LEN=*), intent(in) :: file
    if (io_error/=0) then 
        if (io_error<0) write(*,*) 'ERROR: reached end of file when trying to read in ' // trim(file)
        if (io_error>0) write(*,*) 'ERROR: a serious problem occurred when trying to read in ' // trim(file)
        print*,'io_error is ',io_error,' see fortran documentation'
    end if
end subroutine check_io_error


subroutine check_exist_bool(exist_bool,file)
    implicit none
    logical, intent(in) :: exist_bool
    character(LEN=*), intent(in) :: file
    if (.NOT. exist_bool) then
        write(*,*) 'ERROR: file '// trim(file) //' not found'
    end if
end subroutine check_exist_bool

! Checks whether a file exists. If not, it stops the program.
subroutine check_exist(file)
    implicit none
    character(LEN=*), intent(in) :: file
    !local
    logical :: exist_bool

    inquire(file=filename,exist=exist_bool)
    if (.NOT. exist_bool) then
        write(*,*) 'ERROR: file '// trim(file) //' not found'
        STOP 'read: no error flag present'
    end if

end subroutine check_exist
subroutine check_exist_errorflag(file,flag)
    implicit none
    character(LEN=*), intent(in) :: file
    integer, intent(out) :: flag
    !local
    logical :: exist_bool

    inquire(file=filename,exist=exist_bool)
    if (.NOT. exist_bool) then
        write(*,*) 'ERROR: file '// trim(file) //' not found'
        flag = MYREAD_FAILURE
    else
        flag = MYREAD_SUCCESS
    end if

end subroutine check_exist_errorflag


subroutine check_dims(dim1,dim2,file)
    implicit none
    integer, dimension(1:), intent(in) :: dim1, dim2
    character(LEN=*), intent(in) :: file
    if (any(dim1/=dim2)) then
        write(*,*) 'ERROR: read: dims don''t agree'
        write(*,*) 'File: '//trim(file)
        write(*,*) 'Dims in object: ', dim1
        write(*,*) 'Dims in header: ', dim2
    end if
end subroutine check_dims
subroutine check_dims_errorflag(dim1,dim2,file,flag)
    implicit none
    integer, dimension(1:), intent(in) :: dim1, dim2
    integer, intent(out) :: flag
    character(LEN=*), intent(in) :: file
    if (any(dim1/=dim2)) then
        write(*,*) 'ERROR: read: dims don''t agree'
        write(*,*) 'File: '//trim(file)
        write(*,*) 'Dims in object: ', dim1
        write(*,*) 'Dims in header: ', dim2
        flag = MYREAD_FAILURE        
    else
        flag = MYREAD_SUCCESS
    end if
end subroutine check_dims_errorflag


subroutine get_unit_no(unit_no)
    implicit none
    integer, intent(out) :: unit_no
    logical :: unit_ok, unit_op
    unit_no = 301
    unit_ok = .FALSE.
    unit_op = .TRUE.
    do while (unit_ok .and. (.not. unit_op))   
        inquire(unit=unit_no,exist=unit_ok,opened=unit_op)
        if (unit_ok .and. (.not. unit_op)) then
            exit
        else 
            unit_no=unit_no+1
            if (unit_no>500) write(*,*) 'WARNING: unit_no is greater than 500'
        end if
    end do
end subroutine get_unit_no 

end module mod_myprint
