!!!
!!! A common syntax is used for all of the my read files, so I put them here and just "include" them
!!! 
    character(LEN=*), intent(in) :: str    
    integer, intent(out), optional :: err

    filename = trim(directory) // str // ext
    fileheader  = trim(directory) // str // '_h'// ext    

    !---make sure file and header file exist        
    if (present(err)) then
        err = MYREAD_SUCCESS 
        call check_exist_errorflag(fileheader,err)
        call check_exist_errorflag(filename,err)
        if (err/=MYREAD_SUCCESS) return
    else
        call check_exist(fileheader)
        call check_exist(filename)
    end if

    !---open and read in file header
    call get_unit_no(unit_no)
    open(unit_no,file=fileheader,status='old')
!     read(unit_no,pr_fmt_i,iostat=io_error) dims
    read(unit_no,*,iostat=io_error) dims
    close(unit_no)
    call check_io_error(io_error,fileheader)
    
    !--check that dimensions agree
    if (present(err)) then
        call check_dims_errorflag(shape(obj),dims,str,err)
        if (err/=MYREAD_SUCCESS) return
    else
        call check_dims(shape(obj),dims,str)
    end if 
    
    !---open and read in file
    open(unit_no,file=filename,status='old')
    read(unit_no,*,iostat=io_error) obj
    close(unit_no)
    call check_io_error(io_error,filename)

