program main
    use mod_matlab
    use mod_heapsort
    use mod_quicksort
    implicit none
    integer, parameter :: order = 20
    real(8) :: x(2**order),x0(size(x))
    integer :: rank(size(x))
    integer :: i, iter
    real(8) :: timequick,timeheap,timemerge

    do i = 5,order


        call random_number(x0(1:2**i))

        call tic()
        do iter = 1,20*2**(order-i)
            x(1:2**i) = x0(1:2**i)
            call sub_quicksort(x(1:2**i),rank(1:2**i))
        end do
        call toc(timequick)

        call tic()
        do iter = 1,20*2**(order-i)
            call sub_heapsort(x(1:2**i),rank(1:2**i),x0(1:2**i))
        end do
        call toc(timeheap)

        call tic()
        do iter = 1,20*2**(order-i)
            call sub_sort_vec(x(1:2**i),rank(1:2**i),x0(1:2**i))
        end do
        call toc(timemerge)

        print*,'#n ',2**i,' time quick ',timequick,' time heap ',timeheap,' time merge ',timemerge,' ratio quick/merge ',timequick/timemerge

    end do



end program
