! Calls test for grey lib 
program test_greylib
!     use mod_table
    use mod_csv
    use mod_interp
    use mod_matlab_test
    use mod_quad_test
    use mod_root1dim_test
    use mod_smolyak
    use mod_sort, only: mod_sort__test_sort => test_sort
    use mod_spline_test
    use mod_min1dim_test
    use mod_minNdim_test
    use mod_rootNdim_test
    use mod_project_test
    use mod_mympi_test
    use mod_mympi
    use mod_valueopt_test
    use mod_plot
    use mod_util
    use mod_stata
!     use mod_myhdf5
    use mod_mynlopt_test
    use mod_ident
    use mod_discretear1_test
    use mod_mpislave
    use mod_crs
    use mod_core_test
    use mod_twister_test
    use mod_heapsort_test
    use mod_quicksort_test
    implicit none

    call test_quicksort()
    stop
    call test_heapsort()
    call test_twister()
    stop

    call test_bhunt
    stop
 
    call mympi_init()
    print*,'calling test_mpislave()'; call test_mpislave()
    print*,'calling test_crs()'; call test_crs()
    call mympi_finalize()

    print*,'calling test_gausslegendre'; call test_gausslegendre()
    print*,'calling test_gausshermite'; call test_gausshermite()
    print*,'calling test_bsearch_many'; call test_bsearch_many()
    print*,'Testing quadrature routines'
    print*,'calling test_intPiecewiseLinear'; call test_intPiecewiseLinear
    print*,'calling test_sub_simpsonquad'; call test_sub_simpsonquad
    print*,'calling test_pchip'; call test_pchip()
    print*,'calling test_stata'; call test_stata()

stop
    stop 'checking bsearch_many'
    call test_levenbergmarquardt()
    stop 'checking lm'
stop 'testing mpislave'

    print*,'calling test_util()'; call test_util()
    print*,'calling test_parCRS_MPI()'; call test_parCRS_MPI()
stop 'checking parCRS'





    print*,'calling test_sub_regime_switch_2state_tauchen'; call test_sub_regime_switch_2state_tauchen()
    stop 'checking regime'

    call mympi_init()
    print*,'calling test_identranddraws_MPI'; call test_identranddraws_MPI()
    call mympi_finalize()
stop 'checking ident'



    print*,'calling test_mynlopt'; call test_mynlopt
!     print*,'calling test_myhdf5'; call test_myhdf5()
    print*,'calling test_disp'; call test_disp

stop 'checking plot'

    call test_plot()
    stop 'checking plot'

    ! call test_cubic()

    call mympi_init()
    call test_GA_MPI()
    call mympi_finalize()
    stop 'checking GA MPI'

!     stop 'checking stata'
!     call test_table()
!     stop 'checking table'

    call test_opt_along_dim()

    print*,'calling test_mympi()'; call test_mympi()

    print*,'calling test_root1dim() ! one of the routines has mpi'; call test_root1dim() ! one of the routines has mpi

if (mympi_iproc()==0) then

    print*,'calling '; call test_delim_arg()
    print*,'calling test_CRS()'; call test_CRS()

    print*,'calling test_csv'; call test_csv
    print*,'Testing valueopt routines'
    print*,'calling test_valueopt'; call test_valueopt
    print*,'Testing matlab routines'
    print*,'calling test_colon'; call test_colon
    print*,'calling test_cumsum'; call test_cumsum
    print*,'calling test_disp'; call test_disp
    print*,'calling test_eye'; call test_eye
    print*,'calling test_find'; call test_find
    print*,'calling test_interp1'; call test_interp1
    print*,'calling test_interp1q'; call test_interp1q
    print*,'calling test_interp1qf'; call test_interp1qf
    print*,'calling test_interp1qs'; call test_interp1qs
    print*,'calling test_linspace'; call test_linspace
    print*,'calling test_mtimes'; call test_mtimes
    print*,'calling test_mygemm'; call test_mygemm
    print*,'calling test_null'; call test_null
    print*,'calling test_repmat'; call test_repmat
    print*,'calling test_sort'; call test_sort
    print*,'calling test_sort2'; call test_sort2
    print*,'calling test_sortrows'; call test_sortrows
    print*,'calling test_unique'; call test_unique
    print*, 'Testing (mod_)sort routines'
    print*,'calling mod_sort__test_sort'; call mod_sort__test_sort
    print*,'Testing interp routines'
    print*,'calling test_s2interp'; call test_s2interp
    print*,'calling test_search'; call test_search
    print*,'calling test_smolyak'; call test_smolyak
    print*,'calling test_cheb'; call test_cheb
    print*, 'Testing root1dim routines'
    print*,'calling test_findallroots'; call test_findallroots
    print*, 'Testing min1dim routines'
    print*,'calling test_newton1dim'; call test_newton1dim
    print*,'calling test_simplex1dim'; call test_simplex1dim
    print*,'calling test_brent_min'; call test_brent_min
end if
!     print*, 'Testing rootNdim routines'
!     print*,'calling test_powell'; call test_powell
!     print*,'calling test_broyden'; call test_broyden
    print*, 'Testing minNdim routines'
    print*,'calling test_simplex'; call test_simplex
!     print*,'calling test_parallelsimplex'; call test_parallelsimplex
!     print*,'calling test_simanneal'; call test_simanneal
!     print*,'calling test_parallelsimanneal'; call test_parallelsimanneal
!     print*,'calling test_gridsearch'; call test_gridsearch
!     print*,'calling test_newtonNdim'; call test_newtonNdim
!     print*,'calling test_gradDescent'; call test_gradDescent
!     print*,'calling test_stochGradDescent'; call test_stochGradDescent
!     print*,'calling test_BFGS'; call test_BFGS
!     print*,'calling test_numGradHess'; call test_numGradHess
!     print*,'calling test_compass'; call test_compass
    print*,'calling test_parmin'; call test_parmin
!     print*,'calling test_parrandom'; call test_parrandom
!     print*,'calling test_noisyLM'; call test_noisyLM
!     print*,'calling test_parnoisyLM'; call test_parnoisyLM

    call mympi_finalize()
end program
