function [] = illustration2()

    global g lb ub msize2 trace
    
    fontsize = 11;
    setdefaults(fontsize);
    
    close all
%     clf
    
    mynewfigure(struct('width',5.5,'aspect',.55));
    
for iter = 1:2

%     f = {'FontSize',14};e
    
    if (iter==1)
%         n = 20; np = n; msize = 25; msize2 = 5; axsize = [.4 n+.6 .5 np+.5];
        n = 20; np = n; msize = 16; msize2 = 5; axsize = [.4 n+.6 .5 np+.5];
    else
        n = 100; np = n; msize = 5; msize2 = msize*5/16; axsize = [.4 n+.6 0 np+1];
%         n = 100; np = n; msize = 7; msize2 = msize*5/16; axsize = [.4 n+.6 0 np+1];
    end    
    
    g = gfcn((1:n)',np);
    lb = NaN(n,1);
    ub = NaN(n,1);
    trace = NaN(n,10,2);    
    
    % Solve for the search space for each i by brute force binary
%     for  i = 1:n
%         simplebinary(i,1,np,1);
%     end
    
    % Solve for the search space for i by running the algorithm
    binarymono(1,n,np,true);
%     binarymonoalt(0,n+1,np,true);
    
    
    
    
    %%% DO BINARY SIMPLE MONOTONICITY
    subplot(2,2,2+2*(iter-1))
    
    % Plot the true policy
    plot(1:n,g,'b.','MarkerSize',msize)

    % Plot the search range
    hold on
    for i = 1:n
        addbar(i,lb(i),ub(i))
    end
    plot(1:n,g,'b.','MarkerSize',msize)
    
    hold off 
    
    
    axis(axsize)
    xlabel('$i$');%,f{:});%,'Interpreter','latex')
    ylabel('$i''$');%,f{:});%,'Interpreter','latex')
    title(['Binary monotonicity ($n=n''=',sprintf('%i$)',n)])

    set(gca,'Xtick',[],'Ytick',[],'XTickLabel',[],'YTickLabel',[]);
    
%     fprintf(1,'Binary monotonicity, pct. of search space eliminated: %8.0f \n',100-sum(ub-lb+1)/(n*n')*100);
    fprintf(1,'Binary monotonicity, avg search space: %8.1f \n',sum(ub-lb+1)/n);
    
    %%% DO SIMPLE MONOTONICITY
    subplot(2,2,1+2*(iter-1))

    plot(1:n,g,'b.','MarkerSize',msize)

    hold on
    for i = 1:n
        if (i>1) 
            addbar(i,g(i-1),np)
        else
            addbar(i,1,np)
        end
    end
    plot(1:n,g,'b.','MarkerSize',msize) % draw again, to overwrite but keep legend in same order
    
    hold off 
    
    
    axis(axsize)
    xlabel('$i$');%,'Interpreter','latex')
    ylabel('$i''$');%,'Interpreter','latex')
    title(sprintf('Simple monotonicity ($n=n''=%i$)',n))

    set(gca,'Xtick',[],'Ytick',[],'XTickLabel',[],'YTickLabel',[]);
    
    if (iter==1)
        h = legend('Optimal policy ($g$)','Search space','Location','southeast');
        legend boxoff
        set(h,'FontSize',fontsize);
    end
        
    tmp = [1;g(1:np-1)];
%     fprintf(1,'Simple monotonicity, pct. of search space eliminated: %8.0f \n',100-sum(np-tmp+1)/(n*n')*100);
    fprintf(1,'Simple monotonicity, avg search space: %8.1f \n',sum(np-tmp+1)/n);
    
    
end

% printfig('pics/illustration2');
% print('pics/illustration2','-dpdf','-fillpage');
% print('pics/illustration2','-dpdf');
% print('pics/illustration2','-depsc');

disp('Saving this graph will take a little time')
print('pics/illustration2','-dpng','-r1200');

% 
%     printfig('illustration_binarymono')
%     
%     !open illustration_binarymono.eps
%     !cp illustration_binarymono.eps ../tex
end


function printfig(name)
    
    set(gcf,'PaperUnits','inches','PaperPosition',[0 0 10 6])
    
    print('-depsc',name)
    
    
end

function addbar(i,l,u)

global msize2

% daspect([1,1,1])
w = 1;
h = (u-l);
x = i-.5;
y = l;
% h = rectangle('Position',[x,y,w,h]);...,'FaceColor','r');
% get(h);
% set(h,'EdgeColor',[1 0 0])
% pt = [x,l];
% pt2 = [x+1,l];
% line([pt(1),pt2(1)],[pt(2),pt2(2)],'Color',[0 0 0])

h = .3;
w = .3;
x = i;
% plot([i,i],[l,u],'k:','Linewidth',1) % leave this first so that legend is correct
hndl = plot(repmat(i,[1,u-l+1]),l:u,'o','MarkerSize',msize2,'MarkerEdgeColor',.3*[1,1,1],'MarkerFaceColor',[1,1,1]); % leave this first so that legend is correct
% get(hndl)
% bracket(x,l,w,h);
% bracket(x,u,w,-h);

end

% Adds a bracket, either point up or pointing down, with width 1. The
% bracket is centered at x. Use h negative to point down.
% function bracket(x,y,w,h)
% 
% % Flat line
% pt = [x-w,y];
% pt2 = [x+w,y];
% line([pt(1),pt2(1)],[pt(2),pt2(2)],'Color',[0 0 0])
% 
% % Left vertical line
% pt = [x-w,y];
% pt2 = [x-w,y+h];
% line([pt(1),pt2(1)],[pt(2),pt2(2)],'Color',[0 0 0])
% 
% % Right vertical line
% pt = [x+w,y];
% pt2 = [x+w,y+h];
% line([pt(1),pt2(1)],[pt(2),pt2(2)],'Color',[0 0 0])
% 
% end


function [] = binarymono(ilo,ihi,np,firstiter)
    
    global g lb ub
    
    if firstiter
        lb(1) = 1;
        ub(1) = np;
        g(1) = gfcn(1,np);
        lb(ihi) = g(1);
        ub(ihi) = np;
    end
    
    if (ihi<=ilo+1) 
        return;
    end

    m = floor((ilo+ihi)/2);
    
    g(m) = gfcn(m,np);
    lb(m) = g(ilo);
    ub(m) = g(ihi);
    
    binarymono(ilo,m,np,false);
    binarymono(m,ihi,np,false);

end

function [] = binarymonoalt(ilo,ihi,np,firstiter)
    
    global g lb ub

    if (ihi<=ilo+1) 
        return;
    end

    m = floor((ilo+ihi)/2);
    
    g(m) = gfcn(m,np);
    
    if ilo>=1
        lb(m) = g(ilo);
    else
        lb(m) = 1;
    end
    if ihi<=length(g)
        ub(m) = g(ihi);
    else
        ub(m) = np;
    end
        
    binarymonoalt(ilo,m,np,false);
    binarymonoalt(m,ihi,np,false);

end

% brute force binary search
% brute force binary search
function [] = simplebinary(i,ilo,ihi,stage)
    global g trace
    
    if (ihi<=ilo+1)
        return;
    end
    
    m = floor((ilo+ihi)/2);
 
    trace(i,(stage-1)*2+1) = m;
    trace(i,(stage-1)*2+2) = m+1;

    if (m >= g(i,1)) 
        simplebinary(i,ilo,m,stage+1);
    else
        simplebinary(i,m+1,ihi,stage+1);
    end
end

function cnt = gfcn(i,np)

    persistent grbc
    
    crra = 2;
    
    if size(grbc)~=np
        % Solve for the model
        for j = 1:np
            for j2 = 1:np
                u(j2,j) = (max(1d-14,-j2+j^.36+(1-.025)*j)).^(1-crra)/(1-crra);
%                 u(j2,j) = log(max(0,-j2+j^.36+(1-.025)*j));
            end
        end
        V = zeros(np,1);
        grbc = zeros(np,1);
        for iter = 1:1000
            W = .99*V;
            for j = 1:np
                [V(j),grbc(j)] = max(u(:,j)+W);
            end
        end
%         figure(5),plot(V),figure(1)
    end

    
    cnt = grbc(i);
    
%     cnt = i;
% %     cnt = max(min(round(np*sqrt(i/np)),np),1);
%     cnt = floor(np*sqrt(i/np));
    
%     cnt = min(max(floor(sqrt(i)),1)/floor(sqrt(np)),np);
    
    
%     cnt = grbc(j);
    

end