function [] = illustration3()

    addpath('./matlib012717/','-end'); 
    
    close all
    setdefaults();
%     mynewfigure(struct('aspect',.5));
    mynewfigure(struct('aspect',.9));
    
    X = import_fortran_csv('../fortran_multi/results/searchmap25.csv'); 
    work(X,1)
    
%     X = import_fortran_csv('../fortran_multi/results/searchmap100.csv'); 
%     work(X,3)
    
    print('pics/illustration_multi','-dpng','-r600');

end

function [] = work(X,subplotindstart)
    
    nK = size(X,1);
    nZ = size(X,3);
    
    I = [];
    J = [];
    IP = [];
    I2 = [];
    J2 = [];
    IP2 = [];
    for ip = 1:nK
        for i = 1:nK
            for j = 1:nZ
                if (X(ip,i,j)==1) 
                    I(end+1) = i;
                    J(end+1) = j;
                    IP(end+1) = ip;
                end
                if (X(ip,i,j)==2)
                    I2(end+1) = i;
                    J2(end+1) = j;
                    IP2(end+1) = ip;
                end
            end
        end
    end
    
    fprintf(1,'Percent of search space needlessly checked: %6.2f\n',100*sum(X(:)==1)/numel(X));
    fprintf(1,'Percent of search space when knowing true policy: %6.2f\n',100*sum(X(:)==2)/numel(X));    

    m = 2;
    n = 2;
    i = 1;
    
    if (subplotindstart==1)
        msize = {};
    else
        msize = {'MarkerSize',3};
    end
        

    jloop = [1,nZ,floor((1+nZ)/2)];
%     jloop(end+1) = floor((1+jloop(end))/2);
%     jloop(end+1) = floor((1+jloop(end))/2);
%     jloop(end+1) = floor((1+jloop(end))/2);
    jlabel = {'1','n_2','\lfloor \frac{n_2+1}{2}\rfloor'};
    
    for tmp = 2:length(jloop)
        
        jval = jloop(tmp);
        
        subplot(m,n,i+subplotindstart-1);
        i = i+1;

        if (i>=2)
            jlo = 1;
            lower = plot(I2(J2==jlo),IP2(J2==jlo),'r-','Linewidth',4);
            if (i>=3)
                jhi = jloop(tmp-1);
                hold on
                upper = plot(I2(J2==jhi),IP2(J2==jhi),'r-','Linewidth',4);
                hold off
            else
                hold on
                upper = plot(1:nK,repmat(nK,1,nK),'r-','Linewidth',4);
                hold off
            end
        else
            lower = plot(1:nK,repmat(1,1,nK),'r-','Linewidth',4);            
            hold on
            upper = plot(1:nK,repmat(nK,1,nK),'r-','Linewidth',4);            
            hold off
        end

        hold on 
        search = plot(I(J==jval),IP(J==jval),'o','MarkerEdgeColor',.3*[1,1,1],'MarkerFaceColor','w',msize{:});
        true = plot(I2(J2==jval),IP2(J2==jval),'o','MarkerEdgeColor','b','MarkerFaceColor','b',msize{:});
        hold off
        
        
        xlabel('$i$')
        title(sprintf('$j = %s$',jlabel{tmp}))
        ylabel('$i''$')
        
        axis tight
        
        set(gca,'Xtick',[],'Ytick',[],'XTickLabel',[],'YTickLabel',[]);
        
        if (tmp==length(jloop) && subplotindstart==1)
            fnt = fontoptions();
            hleg = legend([true,search,lower],'Optimal policy ($g$)','Search space','Bounds from $\underline j,\overline j$','location','southeast');
            set(hleg,fnt{:});
            legend boxoff
        end
    end

end