function [] = bicubicSplineTest()

    method = 2;

    f = @(x1,x2) x1.^3.*x2 + x1.*sqrt(abs(x2)) + x2.*x1;

    x1 = linspace(-5,5,10)';
    x2 = linspace(-2,2,15)';
    [X1 X2] = ndgrid(x1,x2);
    
    n1 = length(x1);
    n2 = length(x2);    

    y = f(X1,X2);
    
    xhat1 = linspace(x1(1),x1(n1),100)';
    xhat2 = linspace(x2(1),x2(n2),100)';
    
    [Xhat1 Xhat2] = ndgrid(xhat1,xhat2);
    
    ytrue = f(Xhat1,Xhat2);
    
    subplot(2,2,1)
    surf(X1,X2,y)
%     plot3(X1(:),X2(:),y(:),'.')
    
    
    abcd_table = bicubicSplineCoeff(x1,x2,y,method);
    yhat = bicubicSplineEval(Xhat1(:),Xhat2(:),x1,x2,y,abcd_table,method);
    yhat = reshape(yhat,size(Xhat1));
    
    subplot(2,2,2)
    surf(Xhat1,Xhat2,ytrue)

    subplot(2,2,3)
    surf(Xhat1,Xhat2,yhat)
    
    subplot(2,2,4)
    surf(Xhat1,Xhat2,ytrue-yhat)

    
end