% Bisection method
% Note: this could be easily vectorized, but is not currently.
function [xstar,fevals] = bisect(f,a,b,pmod)

toler = 1d-12;
xtoler = 1d-6;
maxiter = 100;


ya = f(a);
yb = f(b);
fevals = 2;

% Check whether should stop
if (abs(ya)<toler)
    xstar = a;
    return
elseif (abs(yb)<toler)
    xstar = b;
    'here 2'
    return
elseif (sign(ya)==sign(yb))
    fprintf(1,'ya %f yb %f \n',ya,yb);
    error('Root is not bracketed')
end

% Main loop
for iter = 1:maxiter
    % Report progress
    if (mod(iter,pmod)==0)
        fprintf(1,'iter %i a %0.16f b %0.16f ya %f yb %f fevals %i\n ',iter,a,b,ya,yb,fevals);
    end
    
    % Check the stopping criterion
    if abs(b-a)<xtoler
        xstar = (b+a)/2;
        return
    end
    
    % Midpoint
    x = (b+a)/2;
    yx = f(x);

    fevals = fevals + 1;
    
    % Check other stopping criterion
    if abs(yx)<toler
        xstar = x;
        return
    end
        
    % Replace a or b depending on sign of yx
    if (sign(yx)==sign(ya))
        a = x;
        ya = yx;
    else
        b = x;
        yb = yx;
    end

end


end