% Evalutes B_{i,k}(x) given knots at x
% function [B] = bspline(x,i,k,t)
% 
%     % Find the ind such the first index such that x>=t(ind)
%     ind = find(x>=t,1,'first');
% 
%     % Now build up to B_{i,k}(x) starting with B_{i,1}(x). This is only nonzero for i = ind.
%     off = -ind+1;
%     B = zeros(k+1,k);
%     B(ind+off,1) = 1;
% 
%     
%     B(ind,2) = x-;
% 
% 
% 
% end

% Evalutes B_{i,k}(x) given knots t at x
function [B] = bspline(x,i,k,t)

    B = bsplinecore(x,i,k,t);

end


function [B] = bsplinecore(x,i,k,t)

    if (k<=0) 
        error('Bad input value for k, must be >= 1');
    end
    
    n = length(t);
    if (i<1 || i>n-k) 
        B = 0;
        return
    end
    
    if (k==1) 
        B = double(t(i) <= x & x < t(i+1));
    else
        
        % Be careful to not do division by zero
        if (t(i+k-1)==t(i))
            Btmp1 = 0;
        else
            Btmp1 = bsplinecore(x,i,k-1,t).*(x - t(i))./(t(i+k-1)-t(i));
        end
        if (t(i+k)==t(i+1)) 
            Btmp2 = 0;
        else
            Btmp2 = bsplinecore(x,i+1,k-1,t).*(t(i+k)-x)./(t(i+k)-t(i+1));
        end
        % Be careful to not do division by zero
%         Btmp1 = bsplinecore(x,i,k-1,t);
%         Btmp2 = bsplinecore(x,i+1,k-1,t);        
%         Btmp1(Btmp1>0) = Btmp1(Btmp1>0).*(x(Btmp1>0) - t(i))./(t(i+k-1)-t(i));
%         Btmp2(Btmp2>0) = Btmp2(Btmp2>0).*(t(i+k)-x(Btmp2>0))./(t(i+k)-t(i+1));
        
        B = Btmp1 + Btmp2;

%         m = (x - t(i))./(t(i+k-1)-t(i));
%         l = (t(i+k)-x)./(t(i+k)-t(i+1));
%         B = m.*bsplinecore(x,i,k-1,t) + l.*bsplinecore(x,i+1,k-1,t);
        
    end

    
end
