% T = chebEval(z,n)
%
% Evaluates all Chebyshev polynomials of degree <= n at z\in[-1,1]
function T = chebEval(z,n)

    T = NaN(length(z),n+1);

    if (n==0)
        T(:,1) = 1;
    elseif (n==1)
        T(:,1) = 1;        
        T(:,2) = z;
    else
        T(:,1) = 1;        
        T(:,2) = z;
        for i = 3:n+1
            T(:,i) = 2*z.*T(:,i-1) - T(:,i-2);
        end
    end
    
end