% [fhat] = chebSumEval(x,coeff,a,b,n)
%
% Evaluates the Chebyshev approximation at x \in [a,b] given coefficients
function [fhat] = chebSumEval(x,coeff,a,b,n)

% Map x into z
z = (x-a)*(2/(b-a)) - 1;

    
if (n==0) 
    fhat = repmat(coeff(1),size(x));
elseif (n==1) 
    fhat = coeff(1) + coeff(2)*z;
elseif (n>1)
    
    Tm2 = 1;
    Tm1 = z;
    fhat = coeff(1) + coeff(2)*z;

    for i = 3:n+1
        
        T = 2*z.*Tm1 - Tm2;
        
        fhat = fhat + coeff(i)*T;

        Tm2 = Tm1;
        Tm1 = T;

    end
else
    error('n is less than 0')
end

end