% [x s] = cheb_step1(order,a,b)
% Chebyshev collocation approximation. Provided an order (>=0) of 
% approximation and bounds (a,b), computes the order+1 nodes (zeros in this
% case) where a function must be evaluated to approximate it.
function [x s] = cheb_step1(order,a,b)
    s.order = order;
    s.a = a;
    s.b = b;
    [x s.z] = chebZeros(order+1,a,b);
end 