
function [] = cubicSplineTest()
%% Initialization 

method = 2;

x = linspace(-5,5,10)';
x = sort([-5;10*(rand(10,1)-.5);5]);
X = linspace(-5,5,10000)'; 

%% Quadratic
y = x.^2; 
Ytrue = X.^2; 
abcd = cubicSplineCoeff(x,y,method,[-10;10]); 
Y = cubicSplineEval(X,x,abcd);
plot(X,Y,'-',x,y,'.',X,Ytrue,'--')

fprintf(1,'Max error is %f \n',max(abs(Y-Ytrue)));

%% Sqrt
y = sqrt(abs(x)); 
Ytrue = sqrt(abs(X));
abcd = cubicSplineCoeff(x,y,method); 

Y = cubicSplineEval(X,x,abcd);
plot(X,Y,'-',x,y,'.',X,Ytrue,'--')

fprintf(1,'Max error is %f \n',max(abs(Y-Ytrue)));

%% Sqrt(5+x)
y = sqrt(abs(5+x)); 
Ytrue = sqrt(abs(5+X)); 
abcd = cubicSplineCoeff(x,y,method); 

Y = cubicSplineEval(X,x,abcd);
plot(X,Y,'-',x,y,'.',X,Ytrue,'--')

fprintf(1,'Max error is %f \n',max(abs(Y-Ytrue)));

%% Quartic 
y = x.^4; 
Ytrue = X.^4;

Yptrue = 4.*X.^3;
Ypptrue = 12.*X.^2;

abcd = cubicSplineCoeff(x,y,method); 

[Yp Ypp] = cubicSplineDeriv(X,x,abcd);

Y = cubicSplineEval(X,x,abcd);
plot(X,Y,'-',x,y,'.',X,Ytrue,'--')


plot(X,Ypp,'-',X,Ypptrue,'--')
plot(X,Yp,'-',X,Yptrue,'--')
return
fprintf(1,'Max error is %f \n',max(abs(Y-Ytrue)));

%% Cubic
y = x.^3 -1/2*x.^2 + 2*x - 1; 
Ytrue = X.^3 -1/2*X.^2 + 2*X - 1; 
abcd = cubicSplineCoeff(x,y,method); 

Y = cubicSplineEval(X,x,abcd);
plot(X,Y,'-',x,y,'.',X,Ytrue,'--')

% pp = spline(x,y)
% pp.coefs
% abcd

fprintf(1,'Max error is %f \n',max(abs(Y-Ytrue)));


end
