% Applies a nice color scheme and format to the plot given by handle "h"
function [] = mydefaultplotformat(h,varargin)

docolor = 1;
domarker = 1;
doline = 1;

% Process additional arguments
iarg = 1;
while iarg<=nargin-1
    switch varargin{iarg}
        case 'nomarker'
            iarg = iarg + 1;
            domarker = 0;
        case 'noline'
            iarg = iarg + 1;
            doline = 0;
        default
            warning('option not found')
            iarg = iarg + 1;
    end 
end 


col = mycolors();

i = 1;
c(:,i) = col.royal_blue; i = i+1;
c(:,i) = col.crimson; i = i+1;
c(:,i) = col.medium_sea_green; i = i+1;
c(:,i) = col.coral; i = i+1;
c(:,i) = col.dark_magenta; i = i+1;
% c(:,i) = col.salmon; i = i+1; % looks too similar to cora%
% c(:,i) = col.gold; i = i+1; % hard to see
c(:,i) = col.gray; i = i+1;

% http://stackoverflow.com/questions/7326009/matlab-set-lines-color-and-style-order-to-be-applied-in-parallel

% colord = num2cell(get(0,'DefaultAxesColorOrder'),2);
% lineord = cellstr(get(0,'DefaultAxesLineStyleOrder'));

% colord = num2cell(c',2);
% set(h,{'Color'}, colord(rem((1:numel(h))-1,numel(colord))+1));

if (domarker) 
    m = ' o+^v';
else
    m = ' ';
end
if (doline) 
    l = {'-' '--'};
else
    l = {'-'};
end


% if (nargin>1)
%     tmp = varargin{1};
%     if (isfield(tmp,'m'))
%         m = tmp.m;
%     end
%     if (isfield(tmp,'l')) 
%         l = tmp.l; 
%         if size(l,2)>1 
%             l = l';
%         end 
%     end
% end 

% Construct an alternating pattern. For each marker type, exhaust the line styles while circing through the colors.
% Then go to the next market type
nc = size(c,2);
nm = length(m);
nl = length(l);
ic = 1;
im = 1;
il = 1;
for i = 1:numel(h)
    cpat{i} = c(:,ic)';
    mpat{i} = m(im);
    lpat{i} = l{il};
    ic = ic + 1;
    il = il + 1;
    if (ic>nc) 
        ic = 1;
    end
    if (il>nl)
        il = 1;
        im = im + 1; % only advance pattern if required
    end
    if (im>nm)
        im = 1;
    end
end

% Determine whether octave or not
% (http://stackoverflow.com/questions/2246579/how-do-i-detect-if-im-running-matlab-or-octave)
isoctave = exist('OCTAVE_VERSION', 'builtin') ~= 0;

if (isoctave)
    set(h,'LineWidth',2);
else
    set(h,'LineWidth',2);
end 

% findall(h,'type','text')
% 
% set(findall(h,'type','text'),'FontName','Helvetica','FontSize',12);
% 
% % For octave, https://engineeringliberty.wordpress.com/2011/10/07/making-great-plots-in-octave-and-matlab-too/
% % might also work in matlab
% set(findall(h,'-property','FontName'),'Helvetica');
% set(findall(h,'-property','FontSize'),'12');

% set(h,{'Marker'},mpat');
% set(h,{'LineStyle'},lpat');
% set(h,{'Color'},cpat');
for i = 1:numel(h)
    if isoctave()
        set(h(i),{'LineStyle'},lpat{i});
        if (mpat{i}~=' ')
            set(h(i),{'Marker'},mpat{i});
        end
        set(h(i),{'Color'},cpat{i});
    else
        set(h(i),'LineStyle',lpat{i});
        if (mpat{i}~=' ')
            set(h(i),'Marker',mpat{i});
        end
        set(h(i),'Color',cpat{i});
    end
end

% if (nargin==1) 
%     lineord = {'-' '--' '-.'}'; %NOTE: I tried adding markers here, but couldn't get it to work;
%     set(h,{'LineStyle'}, lineord(rem((1:numel(h))-1,numel(lineord))+1));
% else
%     if isempty(varargin{1})
%         
%     else
%         lineord = varargin{1};
%         set(h,{'LineStyle'}, lineord(rem((1:numel(h))-1,numel(lineord))+1));
%     end
% end


end
