function [o] = mygnuplot_defaultlinepattern()

    i = 1;
    colors{i} = '#4169E1'; i = i+1;
    colors{i} = '#FF7F50'; i = i+1;
    colors{i} = '#3CB371'; i = i+1;
    colors{i} = '#DC143C'; i = i+1;
    colors{i} = '#800080'; i = i+1;
    colors{i} = '#808080'; i = i+1;
    colors{i} = '#FFD700'; i = i+1;

    linewidths = 4;

    i = 1;
    dashtypes{i} = 'none'; i = i+1; 
    dashtypes{i} = '.-'; i = i+1;
    dashtypes{i} = '.'; i = i+1;

    % In the epscairo terminal, the standard marker types are 
    % -1 nothing
    % 0 small dot
    % 1 plus sign
    % 6 empty circle
    % 7 filled circle
    % 8 empty up triangle
    % 9 filled up triangle
    % 10 empty down triangle
    % 11 filled down triangle
    % markertypes = {1,6,8,7,9};
    % markersizes = .5;

    % In the eps terminal, the standard looking marker types are
    % -1 nothing
    % 0 very small dot
    % 1 plus sign
    % 6 almost empty circle
    % 7 filled circle
    % 8 empty up triangle
    % 9 filled up triangle
    % 10 empty down triangle
    % 11 filled down triangle
    % 12 empty diamond
    % 13 filled diamond
    markertypes = {7,9,13,1,6,8,12};
    markersizes = 1.5;

    i = 1;
    linestyles{i} = 'lines'; i = i+1; % this produces no markers
    linestyles{i} = 'linespoints'; i = i+1; % this produces lines with marketers
%     linestyles{i} = 'points'; i = i+1; % this would just produce markers

    % solid, then just dashed variants, then solid with markers, the dashed variants with markers

    i = 1;

    im = 1; 
    for ils = 1:length(linestyles)
        for id = 1:length(dashtypes)

            ic = 1+mod(i-1,length(colors));

            o(i).rgb = colors{ic};
            o(i).linewidth = linewidths;
            o(i).linestyle = linestyles{ils};
            o(i).dashtype = dashtypes{id};
            if strcmp(o(i).linestyle,'lines')
                % no marker is used in this case
                o(i).markertype = -1; 
            else
                % marker is used, so set it and go to the next
                o(i).markertype = markertypes{im}; 
                im = 1+mod(im,length(markertypes)); 
            end 
                o(i).markersize = markersizes;
            i = i+1;
        end 
    end 

%     o(1).rgb = '#4169E1';
%     o(2).rgb = '#FF7F50';
%     o(3).rgb = '#3CB371';
%     o(4).rgb = '#DC143C';
%     o(5).rgb = '#800080'; % purple
%     o(6).rgb = '#FFD700'; % gold
%     o(1).linewidth = 4;
%     o(2).linewidth = 4;
%     o(3).linewidth = 4;
%     o(4).linewidth = 4;
%     o(5).linewidth = 4;
%     o(6).linewidth = 4;
%     o(1).dashtype = '-';
%     o(2).dashtype = '_';
%     o(3).dashtype = '_._';
%     o(4).dashtype = '...';
%     o(5).dashtype = '-';
%     o(6).dashtype = '-';

%     fprintf(fid,'%s\n','set linetype 4 lc rgb "#DC143C" linewidth 4 dashtype "."');

end 

