#include <fintrf.h>

!Module containing f90 interfaces to called routines
module mexf90
    implicit none
    interface
    function mxGetPr(mp)
        mwPointer :: mxGetPr,mp
    end function mxGetPr
    function mxGetData(mp)
        mwPointer :: mxGetData,mp
    end function mxGetData
    function mxGetM(mp)
        mwPointer :: mxGetM,mp
    end function mxGetM
    function mxGetN(mp)
        mwPointer :: mxGetN,mp
    end function mxGetN
    function matOpen(filename,mode)
        mwPointer :: matOpen
        character(len=*) :: filename,mode
    end function matOpen
    function matClose(mp)
        integer(kind=4) :: matClose
        mwPointer :: mp
    end function matClose
    function matPutVariable(mp,name,pa)
        integer(kind=4) :: matPutVariable
        mwPointer :: mp,pa
        character(len=*) :: name
    end function matPutVariable
    function matGetVariable(mp,name)
        mwPointer :: matGetVariable
        mwPointer :: mp
        character(len=*) :: name
    end function matGetVariable
    function mxCreateNumericArray(ndim,dims,classid,ComplexFlag)
        mwPointer :: mxCreateNumericArray
        integer(kind=4) :: classid,ComplexFlag
        mwSize,intent(in) :: ndim
        mwSize,dimension(1:ndim),intent(in) :: dims
    end function mxCreateNumericArray
    function mxCreateNumericMatrix(m,n,classid,ComplexFlag)
        mwPointer :: mxCreateNumericMatrix
        integer(kind=4) :: classid,ComplexFlag
        mwSize,intent(in) :: m,n
    end function mxCreateNumericMatrix
    function mxClassIDFromClassName(classname)
        integer(kind=4) :: mxClassIDFromClassName
        character(len=*) :: classname
    end function mxClassIDFromClassName
    function mxGetString(mp,str,strlen)
        integer(kind=4) :: mxGetString
        mwPointer :: mp
        character(len=*) :: str
        mwSize :: strlen
    end function mxGetString
    function mxGetScalar(pm)
        real(8) :: mxGetScalar
        mwPointer :: pm
    end function mxGetScalar
    function mxCreateString(str)
        mwPointer :: mxCreateString
        character(len=*) :: str
    end function mxCreateString
    function mxCreateCharMatrixFromStrings(m,str)
        mwPointer :: mxCreateCharMatrixFromStrings
        mwSize :: m
        character(len=*) :: str(m)
    end function mxCreateCharMatrixFromStrings
    function mxGetNumberOfElements(pm)
        mwPointer :: pm
        mwPointer :: mxGetNumberOfElements
    end function mxGetNumberOfElements
    function mexPrintf(message)
        integer(4) :: mexPrintf
        character(len=*) :: message
    end function mexPrintf
    subroutine mexErrMsgTxt(errormsg)
        character(len=*) :: errormsg
    end subroutine mexErrMsgTxt
    function mxIsInt32(pm)
        integer(4) :: mxIsInt32
        mwPointer :: pm
    end function mxIsInt32
  end interface

end module mexf90

