

!Module containing f90 interfaces to called routines
module mexf90
    implicit none
    interface
    function mxGetPr(mp)
        integer*8 :: mxGetPr,mp
    end function mxGetPr
    function mxGetData(mp)
        integer*8 :: mxGetData,mp
    end function mxGetData
    function mxGetM(mp)
        integer*8 :: mxGetM,mp
    end function mxGetM
    function mxGetN(mp)
        integer*8 :: mxGetN,mp
    end function mxGetN
    function matOpen(filename,mode)
        integer*8 :: matOpen
        character(len=*) :: filename,mode
    end function matOpen
    function matClose(mp)
        integer(kind=4) :: matClose
        integer*8 :: mp
    end function matClose
    function matPutVariable(mp,name,pa)
        integer(kind=4) :: matPutVariable
        integer*8 :: mp,pa
        character(len=*) :: name
    end function matPutVariable
    function matGetVariable(mp,name)
        integer*8 :: matGetVariable
        integer*8 :: mp
        character(len=*) :: name
    end function matGetVariable
    function mxCreateNumericArray(ndim,dims,classid,ComplexFlag)
        integer*8 :: mxCreateNumericArray
        integer(kind=4) :: classid,ComplexFlag
        integer*8,intent(in) :: ndim
        integer*8,dimension(1:ndim),intent(in) :: dims
    end function mxCreateNumericArray
    function mxCreateNumericMatrix(m,n,classid,ComplexFlag)
        integer*8 :: mxCreateNumericMatrix
        integer(kind=4) :: classid,ComplexFlag
        integer*8,intent(in) :: m,n
    end function mxCreateNumericMatrix
    function mxClassIDFromClassName(classname)
        integer(kind=4) :: mxClassIDFromClassName
        character(len=*) :: classname
    end function mxClassIDFromClassName
    function mxGetString(mp,str,strlen)
        integer(kind=4) :: mxGetString
        integer*8 :: mp
        character(len=*) :: str
        integer*8 :: strlen
    end function mxGetString
    function mxGetScalar(pm)
        real(8) :: mxGetScalar
        integer*8 :: pm
    end function mxGetScalar
    function mxCreateString(str)
        integer*8 :: mxCreateString
        character(len=*) :: str
    end function mxCreateString
    function mxCreateCharMatrixFromStrings(m,str)
        integer*8 :: mxCreateCharMatrixFromStrings
        integer*8 :: m
        character(len=*) :: str(m)
    end function mxCreateCharMatrixFromStrings
    function mxGetNumberOfElements(pm)
        integer*8 :: pm
        integer*8 :: mxGetNumberOfElements
    end function mxGetNumberOfElements
    function mexPrintf(message)
        integer(4) :: mexPrintf
        character(len=*) :: message
    end function mexPrintf
    subroutine mexErrMsgTxt(errormsg)
        character(len=*) :: errormsg
    end subroutine mexErrMsgTxt
    function mxIsInt32(pm)
        integer(4) :: mxIsInt32
        integer*8 :: pm
    end function mxIsInt32
  end interface

end module mexf90
