

!Gateway function to sub_vGeneric_egm_fixede
!
![V_a, c_a, apg_a, apb_a, apg_ind_a, apb_ind_a] =
! sub_vGeneric_egm_fixede(CVg_ap, CVb_ap, MPL, qgap_ap, qbap_ap, grid_a, grid_ap, ...
! ap_eq0_ind, len_a, len_ap, dCVg_in, dCVb_in, apg_feasible_in, ...
! apb_feasible_in)
!
! nrhs = 14
! nlhs = 6

subroutine mexFunction(nlhs,plhs,nrhs,prhs)
      use mexf90
      use mod_types
      use mod_value_fcns
      implicit none
      integer(4) :: nlhs, nrhs
      integer*8 :: prhs(*)
      integer*8 :: plhs(*)
      !local

      integer*8 :: m,n
      integer*8 :: len_a_val_ptr
      integer*8 :: dims(2), ndims
      integer :: len_a_val, len_ap_val
      integer*8 :: len_a_val3
      integer*8 :: len_a_val4
      integer*8 :: V_a_ptr, c_a_ptr, apg_a_ptr, apb_a_ptr, apg_ind_a_ptr, apb_ind_a_ptr
      integer*8 :: CVg_ap_ptr, CVb_ap_ptr, MPL_ptr, qgap_ap_ptr, qbap_ap_ptr, grid_a_ptr, grid_ap_ptr, &
                   ap_eq0_ind_ptr, len_a_ptr, len_ap_ptr, dCVg_in_ptr, dCVb_in_ptr, apg_feasible_in_ptr, apb_feasible_in_ptr

      real(dp), dimension(:), allocatable :: V_a,c_a,apg_a,apb_a,CVg_ap,Cvb_ap,qgap_ap, qbap_ap, grid_a, grid_ap, dCVg_in, dCVb_in
      real(dp) :: MPL
      integer, dimension(:), allocatable :: apg_ind_a,apb_ind_a
      integer :: ap_eq0_ind, len_a, len_ap
      logical, dimension(:), allocatable :: apg_feasible_in, apb_feasible_in
      integer, dimension(:), allocatable :: apg_feasible_in_int, apb_feasible_in_int
      character(len=50) :: line

      !Check number of input arguments
      if (nrhs/=14) then
           write(line,*) 'nrhs = ',nrhs, achar(10)
           write(*,*) mexPrintf(line)
           call mexErrMsgTxt('Number of RHS is wrong')
      end if
      if (nlhs/=6) then
           write(line,*) 'nlhs = ',nlhs, achar(10)
           write(*,*) mexPrintf(line)
           call mexErrMsgTxt('Number of LHS is wrong')
      end if

      !Check that integer input arguments are in fact appropriately sized integers
      if (mxIsInt32(prhs(8))+mxIsInt32(prhs(9))+mxIsInt32(prhs(10))+mxIsInt32(prhs(13))+mxIsInt32(prhs(14)) < 5) then
           call mexErrMsgTxt('Some value is not int32')
      end if

      !Check that dimensions conform with length specs len_a and len__ap
      len_a_val = mxGetNumberOfElements(prhs(6))
      len_ap_val = mxGetNumberOfElements(prhs(7))
      call mxCopyPtrToInteger4(mxGetData(prhs(9)), len_a, mxGetNumberOfElements(prhs(9)))
      call mxCopyPtrToInteger4(mxGetData(prhs(10)), len_ap, mxGetNumberOfElements(prhs(10)))
      if (len_a_val /= len_a) then
           call mexErrMsgTxt('len_a is wrongly sized')
      end if
      if (len_ap_val /= len_ap) then
           call mexErrMsgTxt('len_ap is wrongly sized')
      end if

      !Create output data: len_a x 1
      dims = (/len_a_val,1/)
      ndims = 2
      plhs(1) = mxCreateNumericArray(ndims,dims,mxClassIDFromClassName('double'),0) !V_a
      plhs(2) = mxCreateNumericArray(ndims,dims,mxClassIDFromClassName('double'),0) !c_a
      plhs(3) = mxCreateNumericArray(ndims,dims,mxClassIDFromClassName('double'),0) !apg_a
      plhs(4) = mxCreateNumericArray(ndims,dims,mxClassIDFromClassName('double'),0) !apb_a
      plhs(5) = mxCreateNumericArray(ndims,dims,mxClassIDFromClassName('int32'),0) !apg_ind_a
      plhs(6) = mxCreateNumericArray(ndims,dims,mxClassIDFromClassName('int32'),0) !apb_ind_a

      !Allocate data
      allocate(V_a(len_a_val),c_a(len_a_val),apg_a(len_a_val),apb_a(len_a_val),apg_ind_a(len_a_val),apb_ind_a(len_a_val))
      allocate(CVg_ap(len_ap_val), CVb_ap(len_ap_val), qgap_ap(len_ap_val), qbap_ap(len_ap_val), grid_a(len_a_val), &
               grid_ap(len_ap_val), dCVg_in(len_ap_val), dCVb_in(len_ap_val), apg_feasible_in(len_ap_val), &
               apb_feasible_in(len_ap_val), apg_feasible_in_int(len_ap_val), apb_feasible_in_int(len_ap_val))

      !Copy in
      !Use mxGetPr on arrays of type double only! use mxGetData o/w
      call mxCopyPtrToReal8(mxGetPr(prhs(1)), CVg_ap, mxGetNumberOfElements(prhs(1)))
      call mxCopyPtrToReal8(mxGetPr(prhs(2)), CVb_ap, mxGetNumberOfElements(prhs(2)))
      call mxCopyPtrToReal8(mxGetPr(prhs(3)), MPL, mxGetNumberOfElements(prhs(3)))
      call mxCopyPtrToReal8(mxGetPr(prhs(4)), qgap_ap, mxGetNumberOfElements(prhs(4)))
      call mxCopyPtrToReal8(mxGetPr(prhs(5)), qbap_ap, mxGetNumberOfElements(prhs(5)))
      call mxCopyPtrToReal8(mxGetPr(prhs(6)), grid_a, mxGetNumberOfElements(prhs(6)))
      call mxCopyPtrToReal8(mxGetPr(prhs(7)), grid_ap, mxGetNumberOfElements(prhs(7)))
      call mxCopyPtrToInteger4(mxGetData(prhs(8)), ap_eq0_ind, mxGetNumberOfElements(prhs(8)))
      call mxCopyPtrToInteger4(mxGetData(prhs(9)), len_a, mxGetNumberOfElements(prhs(9)))
      call mxCopyPtrToInteger4(mxGetData(prhs(10)), len_ap, mxGetNumberOfElements(prhs(10)))
      call mxCopyPtrToReal8(mxGetPr(prhs(11)), dCVg_in, mxGetNumberOfElements(prhs(11)))
      call mxCopyPtrToReal8(mxGetPr(prhs(12)), dCVb_in, mxGetNumberOfElements(prhs(12)))
      call mxCopyPtrToInteger4(mxGetData(prhs(13)), apg_feasible_in_int, mxGetNumberOfElements(prhs(13)))
      call mxCopyPtrToInteger4(mxGetData(prhs(14)), apb_feasible_in_int, mxGetNumberOfElements(prhs(14)))

      apg_feasible_in = .TRUE.
      apb_feasible_in = .TRUE.
      where (apg_feasible_in_int==0) apg_feasible_in = .FALSE.
      where (apb_feasible_in_int==0) apb_feasible_in = .FALSE.

      !Call computation algorithm
      call sub_vGeneric_egm_fixede(V_a, c_a, apg_a, apb_a, apg_ind_a, apb_ind_a, &
                                   CVg_ap,CVb_ap, MPL, qgap_ap, qbap_ap, grid_a, &
                                   grid_ap,ap_eq0_ind, len_a, len_ap, dCVg_in, &
                                   dCVb_in,apg_feasible_in,apb_feasible_in)

      !Copy out
      call mxCopyReal8ToPtr(V_a, mxGetPr(plhs(1)), mxGetNumberOfElements(plhs(1)))
      call mxCopyReal8ToPtr(c_a, mxGetPr(plhs(2)), mxGetNumberOfElements(plhs(2)))
      call mxCopyReal8ToPtr(apg_a, mxGetPr(plhs(3)), mxGetNumberOfElements(plhs(3)))
      call mxCopyReal8ToPtr(apb_a, mxGetPr(plhs(4)), mxGetNumberOfElements(plhs(4)))
      call mxCopyInteger4ToPtr(apg_ind_a, mxGetData(plhs(5)), mxGetNumberOfElements(plhs(5)))
      call mxCopyInteger4ToPtr(apb_ind_a, mxGetData(plhs(6)), mxGetNumberOfElements(plhs(6)))

      !DO I HAVE TO DESTROY SOME ARRAYS?

      !Deallocate data (shouldn't be necessary)

end subroutine mexFunction


! V_a_ptr = mxGetPr(plhs(1))
! c_a_ptr = mxGetPr(plhs(2))
! apg_a_ptr = mxGetPr(plhs(3))
! apb_a_ptr = mxGetPr(plhs(4))
! apg_ind_a_ptr = mxGetData(plhs(5))
! apb_ind_a_ptr = mxGetData(plhs(6))
!
! CVg_ap_ptr = mxGetPr(prhs(1))
! CVb_ap_ptr = mxGetPr(prhs(2))
! MPL_ptr = mxGetPr(prhs(3))
! qgap_ap_ptr = mxGetPr(prhs(4))
! qbap_ap_ptr = mxGetPr(prhs(5))
! grid_a_ptr = mxGetPr(prhs(6))
! grid_ap_ptr = mxGetPr(prhs(7))
! ap_eq0_ind_ptr = mxGetData(prhs(8))
! len_a_ptr = mxGetData(prhs(9))
! len_ap_ptr = mxGetData(prhs(10))
! dCVg_in_ptr = mxGetPr(prhs(11))
! dCVb_in_ptr = mxGetPr(prhs(12))
! apg_feasible_in_ptr = mxGetData(prhs(13))
! apb_feasible_in_ptr = mxGetData(prhs(14))
