% [Y] = schumakerSplineEval(X,knots,abc)
% 
% Evaluates a quadratic spline at any values of x.
%
% The spline is stored in piecewise polynomial form
% y(x) = a + b(x-xi) + c(x-xi)^2
function [Y] = schumakerSplineEval(X,knots,abc)

% Ensure column vectors
if (~iscolumn(X)) 
    error('X must be a column vector')
end

% Use binary search to find the location of x in that grid
i = bsearch(X,knots);

% Get X-xi
del = X-knots(i);

% Manually do Horner's method
Y = abc(i,1) + (abc(i,2)+abc(i,3).*del).*del;

end

