%function [] = write_to_fortran(x,filename,varargin)
function [] = write_to_fortran(x,filename,varargin)

    kind = [];
    if length(varargin)==1
        kind = varargin{1};
    end

    %Format
    
    
    
%      x = [1.2345689e300,pi*10^10,1.2345689e300,pi,021084,021084e-100,-pi];
    % x = [1 2; .5 0; pi sqrt(2)];
    % x = rand([3,2,5]);
    
    filedir = './write_to_fortran/';
    %filename = 'testing_write';
    fileext = '.txt';
    fileheader = '_h';
    filefullpath = [filedir,filename,fileext];
    filefullpath_h = [filedir,filename,fileheader,fileext];
    
    %I assume the Fortran format is read using pr_fmt_d='(e40.16e4)' and
    %pr_fmt_i='(i8)'

    
    %Write the file header
    dims = size(x);
    if numel(x)==1
        dims = 1;
    end   
    tmp = sprintf('%8i\n',dims);
    fid = fopen(filefullpath_h,'w');
    fprintf(fid,'%s\n',tmp);


    %Check the object for correct print type
    if (all(x==int32(x)) & ~strcmp(kind,'int'))
        warning('x appears to be an integer but is not being written as one.')
    elseif (any(x~=int32(x)) & strcmp(kind,'int'))
        warning('x does not appear to be an integer but is being written as one.')
    end
    
    %Write the file itself
    clear tmp            
    if (strcmp(kind,'int'))
        %PRINT INTEGER
        x = int32(x);
        
        tmp = sprintf('%8i\n',x);
        fid = fopen(filefullpath,'w');
        fprintf(fid,'%s\n',tmp);
    else
        %PRINT DOUBLE
        tmp = sprintf('%-40.16E\n',x);

        leftstart = 1 + (0:numel(x)-1)*41;

        list = cell(numel(x),1);
        for ind = 1:numel(x)
            thisEntry = tmp(1,leftstart(ind):leftstart(ind)+40);
            %thisEntry = tmp(ind,:);

            if (thisEntry(1)=='-')            
                sign = '-';
                decimal = thisEntry(2:19);
                bigE = 'E';
                expon = thisEntry(21:24);
            else
                sign = ' ';
                decimal = thisEntry(1:18);
                bigE = 'E';
                expon = thisEntry(20:23);
            end

            if (expon(4)==' ')
                expon(3:4) = expon(2:3);
                expon(2) = '0';
            end
            expon(3:5) = expon(2:4);
            expon(2) = '0';

            pad = '               ';

            str = [pad,sign,decimal,bigE,expon];

            list{ind} = str;

        end

    %     whos list
    %     disp(list)

    %     disp('from fortran')
    %     disp('               -0.5029445267314303E-0002')
    %     disp('                0.1868221966243659E+0000')
        list = char(list);

        fid = fopen(filefullpath,'w');
        for ind = 1:size(list,1)        
            fprintf(fid,'%s\n',list(ind,:));
        end

    end
        
    
end