#!/bin/bash

export OMP_NUM_THREADS=1

# To delete old file and replace it, uncomment the next line
echo "nB,nK,nZ,method,vfiiter,overtime,timemax,timetotal,evalcnt,docash" > output.csv

job() {
    c=$1 # cash at hand
    m=$2 # method 
    n=$3 # number of grid points

    if [ $c -eq 0 ]; then
        if [ $n -le 100 ] || [ $m -eq 7 ]; then
            ./rbcdef.out ${n} ${n} 21 ${m} 0 ${c}
        fi
    fi
    if [ $c -ge 1 ]; then
        if [ $n -le 500 ] || [ $m -eq 7 ]; then
            ./rbcdef.out ${n} ${n} 21 ${m} 0 ${c}
        fi
    fi

}
export -f job

# Requires GNU parallel to be installed (may use script below if don't want this)
parallel --jobs $GNU_PAR_CORES --joblog gnu_par_log.txt --timeout 6000 job ::: 0 1 2 ::: 1 4 7 ::: 25 50 100 250 500 1000 >> output.csv



# Without GNU parallel
# for arg1 in 0 1 2
# do 
#     for arg2 in 1 4 7
#     do 
#         for arg3 in 2 10 25 50 75 100 250 500 750 1000
#         do 
#             echo $arg1 $arg2 $arg3
#             ./rbcdef.out $arg1 $arg2 $arg3 >> output.csv
#         done
#     done 
# done
