#!/bin/bash

# Select your (MPI-enabled) compilers
# export FC="mpif90"
# export CC="mpicc"
# export CXX="mpicxx"

# Select your (MPI-enabled) compilers #Intel
export FC="mpiifort"
export CC="mpiicc"
export CXX="mpiicpc"

# Select your desired compilation flags
# FCFLAGSMODLOC should give a flag for setting the compilation directory
# intel 
export FCFLAGSSTD="-qopenmp-stubs -mkl=sequential -debug minimal -g -traceback -xHOST -O3 -no-wrap-margin"
export FCFLAGSMODLOC="-module "
# gfortran 
# export FCFLAGSSTD="-O3 -mtune=native -lgomp -pipe -Wall -ffree-line-length-255 -Wno-unused-dummy-argument -std=f2008 -pedantic -fbacktrace -finit-real=nan -g"
# export FCFLAGSMODLOC="-J"


# Set the link line for requires libraries
# Need all the following: OpenMP, BLAS, LAPACK, nlopt (will be compiled), and libm (required by nlopt)
export BLASLAPACK="-mkl=sequential -lnlopt -lm" # Intel
# export BLASLAPACK="-lgomp -framework Accelerate -lnlopt -lm" # Mac / GCC
#export BLASLAPACK= "-lgomp -lblas -llapack -lnlopt -lm" # Linux / system

# Add these to the variables
# FCFLAGS+=-I$INCLGREY -L$LIBGREY -lgrey
